//
//  DialogViewController.swift
//  VKExt
//
//  Created programmist_NA on 31.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import MaterialComponents
import Kingfisher
import RxSwift
import RxKeyboard
import RealmSwift

class DialogViewController: UIBaseCollectionViewController, UIBaseViewControllerProtocol, UIBaseCollectionViewControllerProtocol, ChatViewProtocol {
    var presenter: ChatPresenterProtocol?
    var peerId: Int?
    var conversation: Conversation?
    var messages: Results<Message>?
    var token: NotificationToken?
    lazy var realm = try! Realm()
    var avatarButton: IconButton = {
        let button = IconButton()
        button.clipsToBounds = true
        return button
    }()
    var popButton: IconButton = {
        let button = IconButton(image: UIImage(named: "arrow_left_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(pop), for: .touchDown)
        return button
    }()
    var moreButton: IconButton = {
        let button = IconButton(image: UIImage(named: "more_vertical_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(refreshCollection), for: .touchDown)
        return button
    }()
    var footer: TableFooterView = TableFooterView(frame: CGRect(origin: .zero, size: CGSize(width: Screen.bounds.width, height: 56)))
    let textViewContainer = TextInputContainer(frame: CGRect(origin: .zero, size: CGSize(width: UIScreen.main.bounds.width, height: 42)))
    var customInputView: UIView!
    var shouldAdjustForKeyboard = false
    var disposeBag = DisposeBag()
    var subtitle = ""
    let activityIndicator = MDCActivityIndicator()
    let removedMessageImageView: UIImageView = {
        let imageView = UIImageView(image: UIImage(named: "delete_outline_16")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableGrayVK))
        imageView.autoSetDimensions(to: CGSize(width: 16, height: 16))
        return imageView
    }()
    let imageView: UIImageView = {
        let imageView = UIImageView()
        return imageView
    }()
    var actionSheet: MDCActionSheetController!
    let defaults = UserDefaults.standard
    let fab: MDCFloatingButton = {
        let fab = MDCFloatingButton(shape: .mini)
        fab.setImage(UIImage(named: "chevron_down_24"), for: .normal)
        fab.setBackgroundColor(.adaptableWhite)
        fab.setBorderWidth(0.5, for: .normal)
        fab.setBorderColor(.adaptableGrayVK, for: .normal)
        fab.setElevation(.none, for: .normal)
        fab.addTarget(self, action: #selector(scrollToLast), for: .touchUpInside)
        return fab
    }()
    private var lastContentOffset: CGFloat = 0
    private let cellId = "cellId"
    var isInitialLayout = true
    let keyboardMan = KeyboardManagerService()

    override var canBecomeFirstResponder: Bool {
        return true
    }
    
    override var inputAccessoryView: UIView? {
        if customInputView == nil {
            customInputView = InputAccessoryView()
            customInputView.autoresizingMask = .flexibleHeight
            customInputView.addSubview(textViewContainer)
            textViewContainer.trailingAnchor.constraint(
                equalTo: customInputView.trailingAnchor,
                constant: 0
            ).isActive = true
            
            textViewContainer.leadingAnchor.constraint(
                equalTo: customInputView.leadingAnchor,
                constant: 0
            ).isActive = true
            
            textViewContainer.topAnchor.constraint(
                equalTo: customInputView.topAnchor,
                constant: 0
            ).isActive = true
            
            textViewContainer.bottomAnchor.constraint(
                equalTo: customInputView.layoutMarginsGuide.bottomAnchor,
                constant: 0
            ).isActive = true
        }
        return customInputView
    }
    
    convenience init(conversation: Conversation) {
        self.init()
        self.peerId = conversation.peerId
        self.conversation = conversation
        self.messages = try! Realm().objects(Message.self).filter("peerId == %@", conversation.peerId).sorted(byKeyPath: "dateInt", ascending: false)
    }
    
	override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = .adaptableWhite
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 18), GoogleSansFont.regular(with: 13)])
        prepareCollection()
        initialCollection()
        avatarButton.drawBorder(18, width: 0, color: .clear, isOnlyTopCorners: false)
        initialComponent()
        initialTextView()
        ChatRouter.createModule(self)
        self.presenter?.start(offset: 0, peerId: conversation?.peerId ?? 0, count: 75)
        self.setupToolbar(title: self.conversation?.interlocutorName ?? "", subtitle: self.conversation?.isOnline ?? false ? "online" : self.subtitle, leftViews: [self.popButton, self.avatarButton], rightViews: [self.moreButton])
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
        
        if isInitialLayout {
            defer {
                isInitialLayout = false
            }
            keyboardMan.animateWhenKeyboardAppear = { [weak self] duration, options, appearPostIndex, keyboardHeight, keyboardHeightIncrement in
                if let self = self, appearPostIndex > 0 {
                    self.bottomConstraint?.constant = -keyboardHeightIncrement
                    UIView.animate(withDuration: duration, delay: 0, options: options, animations: {
                        self.view.layoutIfNeeded()
                    })
                }
            }
            keyboardMan.animateWhenKeyboardDisappear = { [weak self] duration, options, keyboardHeight in
                if let self = self {
                    self.bottomConstraint?.constant = keyboardHeight - self.textViewContainer.bounds.height
                    UIView.animate(withDuration: duration, delay: 0, options: options, animations: {
                        self.view.layoutIfNeeded()
                    })
                }
            }
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
//        token = messages?.observe { [weak mainCollection, weak self] changes in
//            guard let collectionView = mainCollection else { return }
//            guard let self = self else { return }
//
//            switch changes {
//            case .initial:
//                collectionView.reloadData()
//            case .update(_, let deletions, let insertions, let updates):
//                for insert in insertions {
//                    let message = self.messages![insert]
//                    self.messageViewModels.insert(MessageDataModel(message: message, conversation: self.conversation!), at: insert)
//                }
//                for delete in deletions {
//                    self.messageViewModels.remove(at: delete)
//                }
//                for update in updates {
//                    self.updateModel(at: update, from: self.messages![update])
//                }
//                collectionView.applyChanges(deletions: deletions, insertions: insertions, updates: updates)
//            case .error: break
//            }
//            DispatchQueue.main.asyncAfter(deadline: .now() + 0.5) {
//                collectionView.reloadData()
//            }
//        }
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        shouldAdjustForKeyboard = true
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        shouldAdjustForKeyboard = false
        self.textViewContainer.textView.resignFirstResponder()
        defaults.set(textViewContainer.textView.text, forKey: "message_\(peerId!)")
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        initialExtensionToolbar()
        toolbar.title = title
        toolbar.detail = subtitle
        toolbar.titleLabel.textAlignment = .left
        toolbar.titleLabel.padding = UIEdgeInsets(top: 5, left: 0, bottom: 0, right: 0)
        toolbar.detailLabel.textAlignment = .left
        toolbar.detailLabel.padding = UIEdgeInsets(top: 0, left: 0, bottom: 5, right: 0)
        toolbar.titleLabel.font = GoogleSansFont.medium(with: 16)
        toolbar.detailLabel.font = GoogleSansFont.regular(with: 13)
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
    }
    
    func initialExtensionToolbar() {
        self.avatarButton.addSubview(imageView)
        imageView.autoCenterInSuperview()
        imageView.autoSetDimensions(to: CGSize(width: 40, height: 40))
        if let avatarPhoto = conversation?.interlocutorPhoto100, avatarPhoto != "", !avatarPhoto.contains("vk.com/images/camera_") {
            KingfisherManager.shared.retrieveImage(with: URL(string: avatarPhoto)!) { [weak self] result in
                guard let self = self else { return }
                switch result {
                case .success(let value):
                    DispatchQueue.main.async {
                        self.imageView.drawBorder(20, width: 0, color: .clear, isOnlyTopCorners: false)
                        self.imageView.image = value.image.resize(toWidth: 40)?.resize(toHeight: 40)
                    }
                case .failure(let error):
                    print(error.localizedDescription)
                }
            }
        } else {
            DispatchQueue.main.async {
                self.imageView.drawBorder(20, width: 0, color: .clear, isOnlyTopCorners: false)
                let lastIndex: Int = Int(String("\(self.peerId!)".last ?? "0")) ?? 0
                Conversation.getAvatarAcronymColor(at: lastIndex) { [weak self] (gradient) in
                    guard let self = self else { return }
                    self.imageView.setImageForName(self.conversation?.interlocutorName ?? "", gradientColors: gradient ?? UIColor.extendedBlueGradient, circular: true, textAttributes: [.font: GoogleSansFont.medium(with: 12), .foregroundColor: UIColor.white])
                }
            }
        }
        if self.conversation?.type == ConversationPeerType.user.rawValue {
            self.subtitle = self.conversation!.lastSeen > 0 ? CommonService.getLastSeen(sex: self.conversation!.sex, time: Date(timeIntervalSince1970: Double(self.conversation!.lastSeen))) : "\(self.conversation?.sex == 1 ? "была в сети недавно" : "был в сети недавно")"
        } else if self.conversation?.type == ConversationPeerType.group.rawValue {
            self.subtitle = "сообщество"
        } else {
            self.subtitle = "\(self.conversation?.membersCount ?? 0) \(self.getStringByDeclension(number: self.conversation?.membersCount ?? 0, arrayWords: Localization.instance.membersString))"
        }
    }
    
    func initialCollection() {
        self.view.addSubview(fab)
        fab.autoPinEdge(.bottom, to: .bottom, of: self.view, withOffset: -self.textViewContainer.bounds.height - 16)
        fab.autoPinEdge(.trailing, to: .trailing, of: self.view, withOffset: -16)
        mainCollection.register(ChatLogMessageCell.self, forCellWithReuseIdentifier: cellId)
        mainCollection.backgroundColor = .adaptableWhite
        mainCollection.delegate = self
        mainCollection.dataSource = self
        mainCollection.keyboardDismissMode = .onDrag
        let longPressGestureRecognizer = UILongPressGestureRecognizer(target: self, action: #selector(handleLongPress(_:)))
        longPressGestureRecognizer.minimumPressDuration = 0.2
        mainCollection.addGestureRecognizer(longPressGestureRecognizer)
        let tapGestureRecognizer = UITapGestureRecognizer(target: self, action: #selector(handleTap(_:)))
        tapGestureRecognizer.numberOfTouchesRequired = 1
        mainCollection.addGestureRecognizer(tapGestureRecognizer)
    }
    
    func initialComponent() {
        // Progress indicator
        activityIndicator.sizeToFit()
        view.addSubview(activityIndicator)
        activityIndicator.autoCenterInSuperview()
        activityIndicator.radius = 15
        activityIndicator.strokeWidth = 3
        activityIndicator.indicatorMode = .indeterminate
        activityIndicator.cycleColors = [.extendedBlue]
        
        textViewContainer.setup(placeholder: "Сообщение", canWriteAllow: conversation?.canWriteAllowed ?? true, writeNotAllowReason: conversation?.getCanWriteMessage(by: conversation?.canWriteReason ?? 0) ?? "")
    }
    
    func initialFooter() {
        self.view.addSubview(devView)
        devView.autoCenterInSuperview()
        devView.setup(page: "чата", image: UIImage(named: "message_read_outline_56")!)
    }
    
    func initialTextView() {
        if defaults.string(forKey: "message_\(peerId!)") != nil {
            textViewContainer.textView.text = defaults.string(forKey: "message_\(peerId!)")
        }
        textViewContainer.sendButton.alpha = defaults.string(forKey: "message_\(peerId!)") != nil ? 1 : 0.5
        textViewContainer.sendButton.isEnabled = defaults.string(forKey: "message_\(peerId!)") != nil
        textViewContainer.textView.delegate = self
        textViewContainer.sendButton.addTarget(self, action: #selector(onTapSend), for: .touchUpInside)
        textViewContainer.editingModeButton.addTarget(self, action: #selector(onTapEndEditing), for: .touchUpInside)
    }
    
    func handleLoading(from isNeed: Bool) {
        if isNeed {
            activityIndicator.isHidden = false
            mainCollection.isHidden = true
            activityIndicator.startAnimating()
        } else {
            activityIndicator.isHidden = true
            mainCollection.isHidden = false
            activityIndicator.stopAnimating()
        }
    }
    
    func finish() {
        toolbar.detailLabel.attributedText = NSAttributedString(string: toolbar.detailLabel.text ?? "") + NSAttributedString(string: " · \(presenter!.messagesCount) \(self.getStringByDeclension(number: presenter!.messagesCount, arrayWords: Localization.instance.messagesCount))")
        mainCollection.scrollToItem(at: IndexPath(row: 0, section: 0), at: .bottom, animated: false)
    }
    
    func updateFooter(text: String, _ state: Int) {
        self.footer.setup(text: text, state)
    }
    
    @objc func refreshCollection(_ sender: Any?) {
        mainCollection.reloadData()
    }
    
    @objc func pop(_ sender: IconButton) {
        self.navigationController?.popViewController(animated: true)
    }
    
    @objc func handleTap(_ gestureRecognizer: UITapGestureRecognizer) {
        self.textViewContainer.textView.resignFirstResponder()
    }
    
    @objc func scrollToLast(_ sender: MDCFloatingButton) {
        /// self.scrollToFirstItem()
    }
    
    @objc func handleLongPress(_ gestureRecognizer: UILongPressGestureRecognizer?) {
        guard let point = gestureRecognizer?.location(in: mainCollection) else { return }
        let indexPath = mainCollection.indexPathForItem(at: point)
        if indexPath == nil {
            print("Long press on table view, not row.")
        } else if gestureRecognizer?.state == .began {
            self.textViewContainer.textView.resignFirstResponder()
            guard let conversation = conversation else { return }
            let message = messages![indexPath!.item]
            self.initialActionSheet(title: "Сообщение", message: "от \(message.fromId)", actions: self.getActions(at: conversation, from: indexPath!))
        }
    }
    
    @objc func onTapEndEditing(_ sender: IconButton) {
        textViewContainer.isEditingMode = false
        textViewContainer.textView.text = ""
        textViewContainer.resignFirstResponder()
        textViewContainer.setupEditingMode()
        if defaults.string(forKey: "message_\(peerId!)") != nil {
            textViewContainer.textView.text = defaults.string(forKey: "message_\(peerId!)")
        }
    }
    
    @objc func onTapSend(_ sender: IconButton) {
//        guard self.textViewContainer.textView.text != "" && !textViewContainer.isEditingMode else {
//            presenter?.onEditMessage(message: self.textViewContainer.textView.text, messageId: defaults.integer(forKey: "editMessageId"), peerId: self.peerId!)
//            self.textViewContainer.isEditingMode = false
//            self.textViewContainer.setupEditingMode()
//            self.textViewContainer.textView.text = ""
//            self.textViewContainer.sendButton.alpha = 0.5
//            self.textViewContainer.sendButton.isEnabled = false
//            self.textViewContainer.invalidateIntrinsicContentSize()
//            self.updateTextViewSizes()
//            return
//        }
//        let message = self.textViewContainer.textView.text
//        let randomId = Int64.random(in: 0...Int64.max)
//        DispatchQueue.global(qos: .default).asyncAfter(deadline: .now() + 0.2) {
//            let realm = try! Realm()
//            if let lastConversationMessageId = self.messageViewModels.first?.conversationMessageId {
//                guard let conversation = realm.objects(Conversation.self).filter("peerId == %@", self.peerId!).first else { return }
//                let newMessage = Message(date: Date(), fromId: VKConstants.currentUserId, peerId: self.peerId!, text: message ?? "", conversationMessageId: lastConversationMessageId + 1, randomId: randomId, hasAttachments: false, attachmentType: "", forwardMessagesCount: 0, hasForwardedMessages: false, hasReplyMessage: false, conversation: conversation)
//                try! realm.write({
//                    realm.add(newMessage, update: .modified)
//                })
//            }
//        }
//        presenter?.onSendMessage(message: self.textViewContainer.textView.text, peerId: self.peerId ?? 0, randomId: randomId)
//        self.textViewContainer.textView.text = ""
//        defaults.removeObject(forKey: "message_\(peerId!)")
//        defaults.synchronize()
//        self.textViewContainer.sendButton.alpha = 0.5
//        self.textViewContainer.sendButton.isEnabled = false
//        self.textViewContainer.invalidateIntrinsicContentSize()
//        self.updateTextViewSizes()
    }
}
extension DialogViewController {
    func registerKeyboardNotifications() {
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillShow(_:)), name: UIResponder.keyboardWillChangeFrameNotification, object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillHide(_:)), name: UIResponder.keyboardWillHideNotification, object: nil)
    }
     
    @objc func keyboardWillShow(_ notification: NSNotification) {
        adjustContentForKeyboard(notification: notification)
    }
    
    @objc func keyboardWillHide(_ notification: NSNotification) {
        adjustContentForKeyboard(notification: notification)
    }
    
    func adjustContentForKeyboard(notification: NSNotification) {
        guard shouldAdjustForKeyboard, let payload = KeyboardNotification(from: notification) else { return }
     
        let keyboardScreenEndFrame = payload.endFrame
        let keyboardScreenStartFrame = payload.startFrame
        let keyboardViewEndFrame = view.convert(keyboardScreenEndFrame, from: view.window)
        let keyboardViewStartFrame = view.convert(keyboardScreenStartFrame, from: view.window)
     
        UIView.animate(withDuration: payload.timeInterval, delay: 0, options: payload.animationOptions, animations: {
            if notification.name == UIResponder.keyboardWillHideNotification {
                guard self.mainCollection.contentOffset.y != -self.textViewContainer.bounds.height else { return }
                self.mainCollection.contentOffset.y -= (keyboardViewStartFrame.height * 2) - (self.textViewContainer.bounds.height * 2)
            } else {
                self.mainCollection.contentOffset.y += keyboardViewEndFrame.height - self.view.safeAreaInsets.bottom - self.textViewContainer.bounds.height
            }
        }, completion: nil)
    }
}
extension DialogViewController: UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout {
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        if let count = messages?.count {
            return count
        }
        return 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: cellId, for: indexPath) as! ChatLogMessageCell
        cell.transform = GlobalConstants.transform
        cell.messageTextView.text = messages?[indexPath.item].text
        cell.timeStampLabel.text = messages?[indexPath.item].date
        if let message = messages?[indexPath.item], let profileImageName = conversation?.interlocutorPhoto100 {
            cell.profileImageView.kf.setImage(with: URL(string: profileImageName))
            
            let size = CGSize(width: screenWidth - (screenWidth / 3.75), height: 1000)
            let options = NSStringDrawingOptions.usesFontLeading.union(.usesLineFragmentOrigin)
            let estimatedFrame = NSString(string: message.text).boundingRect(with: size, options: options, attributes: [.font: GoogleSansFont.regular(with: 19)], context: nil)
            let estimatedTimeStampFrame = NSString(string: message.date).boundingRect(with: size, options: options, attributes: [.font: GoogleSansFont.regular(with: 12)], context: nil)
            
            setupFrame(cell: cell, isOut: message.out.boolValue, estimatedFrame: estimatedFrame, estimatedTimeStampFrame: estimatedTimeStampFrame)
        }
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        if let messageText = messages?[indexPath.item].text, let date = messages?[indexPath.item].date {
            let size = CGSize(width: screenWidth - (screenWidth / 3.75), height: 1000)
            let options = NSStringDrawingOptions.usesFontLeading.union(.usesLineFragmentOrigin)
            let estimatedFrame = NSString(string: messageText).boundingRect(with: size, options: options, attributes: [NSAttributedString.Key.font: GoogleSansFont.regular(with: 19)], context: nil)
            let estimatedTimeStampFrame = NSString(string: date).boundingRect(with: size, options: options, attributes: [.font: GoogleSansFont.regular(with: 12)], context: nil)
            if estimatedFrame.width >= size.width {
                return CGSize(width: view.frame.width, height: estimatedFrame.height + 20 + estimatedTimeStampFrame.height)
            } else {
                return CGSize(width: view.frame.width, height: estimatedFrame.height + 20)
            }
        }
        
        return CGSize(width: view.frame.width, height: 100)
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAt section: Int) -> UIEdgeInsets {
        return UIEdgeInsets(top: 2, left: 0, bottom: 0, right: 0)
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        textViewContainer.textView.endEditing(true)
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 1
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, referenceSizeForHeaderInSection section: Int) -> CGSize {
        return .zero
    }
    
    func numberOfSections(in collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func setupFrame(cell: ChatLogMessageCell, isOut: Bool, estimatedFrame: CGRect, estimatedTimeStampFrame: CGRect) {
        if !isOut {
            cell.messageTextView.frame = CGRect(x: 48, y: 6, width: (estimatedFrame.width + 24) + estimatedTimeStampFrame.width, height: estimatedFrame.height + 14)
            
            cell.textBubbleView.frame = cell.messageTextView.frame
            
            cell.timeStampLabel.frame = CGRect(origin: CGPoint(x: cell.messageTextView.frame.maxX - estimatedTimeStampFrame.size.width - 12, y: cell.messageTextView.frame.maxY - estimatedTimeStampFrame.size.height - 6), size: estimatedTimeStampFrame.size)
            
            cell.profileImageView.isHidden = false
            
            cell.textBubbleView.backgroundColor = Constants.kIncomingBubbleColor
            cell.messageTextView.textColor = .adaptableBlack
        } else {
            cell.messageTextView.frame = CGRect(x: view.frame.width - estimatedFrame.width - 42 - estimatedTimeStampFrame.width, y: 6, width: (estimatedFrame.width + 24) + estimatedTimeStampFrame.width, height: estimatedFrame.height + 14)
            
            cell.textBubbleView.frame = cell.messageTextView.frame
            
            cell.timeStampLabel.frame = CGRect(origin: CGPoint(x: cell.messageTextView.frame.maxX - estimatedTimeStampFrame.size.width - 12, y: cell.messageTextView.frame.maxY - estimatedTimeStampFrame.size.height - 6), size: estimatedTimeStampFrame.size)
            
            cell.profileImageView.isHidden = true
            
            cell.textBubbleView.backgroundColor = Constants.kOutgoingBubbleColor
            cell.messageTextView.textColor = .adaptableBlack
        }
    }
}
extension DialogViewController: TextViewDelegate {
    func textView(textView: TextView, willShowKeyboard value: NSValue) {
        self.textViewContainer.setupEditingMode()
    }

    func textViewDidChange(_ textView: UITextView) {
        if textView.text != "" {
            UIView.animate(withDuration: 0.2, animations: {
                self.textViewContainer.sendButton.alpha = 1
                self.view.layoutIfNeeded()
            }, completion: { _ in
                self.textViewContainer.sendButton.isEnabled = true
            })
        } else {
            UIView.animate(withDuration: 0.2, animations: {
                self.textViewContainer.sendButton.alpha = 0.5
                self.view.layoutIfNeeded()
            }, completion: { _ in
                self.textViewContainer.sendButton.isEnabled = false
            })
        }
        UIView.animate(withDuration: 0.2, animations: {
            self.textViewContainer.textViewHeight(from: textView.requiredHeight)
            self.textViewContainer.invalidateIntrinsicContentSize()
            self.view.layoutIfNeeded()
        })
    }
}
extension DialogViewController {
    func getActions(at conversation: Conversation, from indexPath: IndexPath) -> [MDCActionSheetAction] {
        let message = messages![indexPath.item]
        guard let presenter = presenter else { return [] }
        let readConversation = MDCActionSheetAction(title: "Прочитать", image: UIImage(named: "view_outline_28"), handler: { action in
        })
        let copy = MDCActionSheetAction(title: "Скопировать", image: UIImage(named: "copy_outline_28"), handler: { action in
        })
        let reply = MDCActionSheetAction(title: "Ответить", image: UIImage(named: "reply_outline_28"), handler: { action in
            
        })
        let edit = MDCActionSheetAction(title: "Редактировать", image: UIImage(named: "edit_outline_28"), handler: { [weak self] action in
            guard let self = self else { return }
            self.defaults.set(message.id, forKey: "editMessageId")
            self.textViewContainer.isEditingMode = true
            self.textViewContainer.textView.becomeFirstResponder()
            if self.textViewContainer.textView.text != "" {
                self.defaults.set(self.textViewContainer.textView.text, forKey: "message_\(self.peerId!)")
                self.textViewContainer.textView.text = ""
            }
            self.textViewContainer.textView.text = message.text
            self.updateTextViewSizes()
            presenter.onEditMessage(message: self.textViewContainer.textView.text, messageId: message.id, peerId: self.peerId!)
        })
        let share = MDCActionSheetAction(title: "Переслать", image: UIImage(named: "share_outline_28"), handler: { action in
            
        })
        let remove = MDCActionSheetAction(title: "Удалить", image: UIImage(named: "delete_outline_28"), handler: { [weak self] action in
            guard let self = self else { return }
            if Int(Date().timeIntervalSince1970) - message.dateInt >= 86400 {
                presenter.onDeleteMessage(messageId: message.id, removeFromAll: false)
            } else {
                self.actionSheet.dismiss(animated: true) {
                    self.initialActionSheet(title: "Удаление сообщения", message: "", actions: self.getAdditionalActions(at: conversation, from: indexPath))
                }
            }
        })
        let removeFromDB = MDCActionSheetAction(title: "Удалить из базы", image: UIImage(named: "delete_outline_28"), handler: { [weak self] action in
            
        })
        remove.titleColor = .extendedRed
        remove.tintColor = .extendedRed
        removeFromDB.titleColor = .extendedRed
        removeFromDB.tintColor = .extendedRed
        if message.unreadStatus == .unreadOut && message.isRemoved {
            return [copy, reply, share, removeFromDB]
        } else if message.unreadStatus == .unreadOut && !message.isRemoved {
            if Int(Date().timeIntervalSince1970) - message.dateInt >= 86400 {
                return [copy, reply, share, remove]
            } else {
                return [copy, reply, edit, share, remove]
            }
        } else {
            if Int(Date().timeIntervalSince1970) - message.dateInt >= 86400 {
                return [readConversation, copy, reply, share, message.isRemoved ? removeFromDB : remove]
            } else {
                return [readConversation, copy, reply, edit, share, message.isRemoved ? removeFromDB : remove]
            }
        }
    }
    
    func getAdditionalActions(at conversation: Conversation, from indexPath: IndexPath) -> [MDCActionSheetAction] {
        let message = messages![indexPath.item]
        guard let presenter = presenter else { return [] }
        let removeFromMe = MDCActionSheetAction(title: "Удалить у меня", image: UIImage(named: "delete_outline_28"), handler: { action in
            presenter.onDeleteMessage(messageId: message.id, removeFromAll: false)
        })
        let removeFromAll = MDCActionSheetAction(title: "Удалить у всех", image: UIImage(named: "delete_outline_28"), handler: { action in
            presenter.onDeleteMessage(messageId: message.id, removeFromAll: true)
        })
        removeFromMe.titleColor = .extendedRed
        removeFromMe.tintColor = .extendedRed
        removeFromAll.titleColor = .extendedRed
        removeFromAll.tintColor = .extendedRed
        return [removeFromMe, removeFromAll]
    }
}
extension DialogViewController {
    func scrollViewWillBeginDragging(_ scrollView: UIScrollView) {
        lastContentOffset = scrollView.contentOffset.y
    }

    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        if scrollView.contentOffset.y >= 1000 {
            UIView.animate(withDuration: 0.2, animations: { [weak self] in
                guard let strongSelf = self else { return }
                strongSelf.fab.alpha = 1.0
                strongSelf.fab.transform = CGAffineTransform.identity.scaledBy(x: 1, y: 1)
            }, completion: nil)
        } else if scrollView.contentOffset.y < 1000 {
            UIView.animate(withDuration: 0.2, animations: { [weak self] in
                guard let strongSelf = self else { return }
                strongSelf.fab.alpha = 0
                strongSelf.fab.transform = CGAffineTransform.identity.scaledBy(x: 0.1, y: 0.1)
            }, completion: nil)
        }
    }
    
    func updateTextViewSizes() {
        UIView.animate(withDuration: 0.2, animations: {
            self.textViewContainer.textViewHeight(from: self.textViewContainer.textView.requiredHeight)
            self.textViewContainer.invalidateIntrinsicContentSize()
            self.view.layoutIfNeeded()
        })
    }
}
